/* csg.h
 * Giram - A GPLed Modelling Program.
 * Copyright (C) 1999-2002 DindinX <David@dindinx.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __CSG_H__
#define __CSG_H__

#include "object.h"

typedef enum
{
  CSG_DIFFERENCE,
  CSG_INTERSECTION,
  CSG_MERGE,
  CSG_UNION
} GiramCSGType;

typedef struct CSGStruct
{
  ObjectStruct Object;

  GiramCSGType Type;
  GSList *all_objects;
} CSGStruct;

ObjectStruct *giram_csg_new(GiramCSGType type);

#endif /* __CSG_H__ */
