/* girammultivpan.h
 *
 * Giram, a GPLed 3D modeller.
 * Copyright (C) 2002 DindinX <David@dindinx.org>
 *    
 * GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the GTK+ Team and others 1997-2000.  See the AUTHORS
 * file for a list of people on the GTK+ Team.  See the ChangeLog
 * files for a list of changes.  These files are distributed with
 * GTK+ at ftp://ftp.gtk.org/pub/gtk/. 
 */

#ifndef __GIRAM_MULTIVPAN_H__
#define __GIRAM_MULTIVPAN_H__

#include "girammultipan.h"

G_BEGIN_DECLS

#define GIRAM_TYPE_MULTIVPAN            (giram_multivpan_get_type())
#define GIRAM_MULTIVPAN(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GIRAM_TYPE_MULTIVPAN, GiramMultivpan))
#define GIRAM_MULTIVPAN_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), GIRAM_TYPE_MULTIVPAN, GiramMultivpanClass))
#define GIRAM_IS_MULTIVPAN(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GIRAM_TYPE_MULTIVPAN))
#define GIRAM_IS_MULTIVPAN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GIRAM_TYPE_MULTIVPAN))
#define GIRAM_MULTIVPAN_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), GIRAM_TYPE_MULTIVPAN, GiramMultivpanClass))


typedef struct _GiramMultivpan      GiramMultivpan;
typedef struct _GiramMultivpanClass GiramMultivpanClass;

struct _GiramMultivpan
{
  GiramMultipan paned;
};

struct _GiramMultivpanClass
{
  GiramMultipanClass parent_class;
};

GType      giram_multivpan_get_type(void) G_GNUC_CONST;
GtkWidget *giram_multivpan_new     (void);

G_END_DECLS

#endif /* __GIRAM_MULTIVPAN_H__ */
